Index: utils/CI/sette_ticket2459/input_ISOMIP+.cfg
===================================================================
--- utils/CI/sette_ticket2459/input_ISOMIP+.cfg	(revision 12878)
+++ utils/CI/sette_ticket2459/input_ISOMIP+.cfg	(revision 12878)
@@ -0,0 +1,1 @@
+ISOMIP+_v4.0.tar ISOMIP+_v4.0
Index: utils/CI/sette_ticket2459/param.cfg
===================================================================
--- utils/CI/sette_ticket2459/param.cfg	(revision 12876)
+++ utils/CI/sette_ticket2459/param.cfg	(revision 12878)
@@ -3,6 +3,6 @@
 # REFERENCE run.stat tracer.stat you want to compare with
 # (if no change to the default, no check on result change will be done)
-NEMO_VALIDATION_REF=/path/to/reference/sette/results
-NEMO_REV_REF=0000
+NEMO_VALIDATION_REF=/projects/jmmp/pmathiot/NEMO/NEMO_dev/NEMO/trunk/NEMO_VALIDATION
+NEMO_REV_REF=12650
 #
 # ------------------------------------------------------------------------------------------
@@ -74,5 +74,5 @@
 # LIST OF CONFIGURATIONS
 # to be updated if you added an new configuration in sette_test-cases.sh or sette_reference-configuration.sh
-TEST_CONFIGS=${SETTE_TEST_CONFIGS:-"ORCA2_ICE_PISCES ORCA2_OFF_PISCES AMM12 AGRIF SPITZ12 GYRE_PISCES SAS ORCA2_ICE_OBS ICE_AGRIF OVERFLOW LOCK_EXCHANGE VORTEX ISOMIP"}
+TEST_CONFIGS=${SETTE_TEST_CONFIGS:-"ORCA2_ICE_PISCES ORCA2_OFF_PISCES AMM12 AGRIF SPITZ12 GYRE_PISCES SAS ORCA2_ICE_OBS ICE_AGRIF OVERFLOW LOCK_EXCHANGE VORTEX ISOMIP+"}
 # ------------------------------------------------------------------------------------------
 #
Index: utils/CI/sette_ticket2459/sette_list_avail_cfg.sh
===================================================================
--- utils/CI/sette_ticket2459/sette_list_avail_cfg.sh	(revision 12876)
+++ utils/CI/sette_ticket2459/sette_list_avail_cfg.sh	(revision 12878)
@@ -16,4 +16,4 @@
 printf "%-15s \n" VORTEX
 printf "%-15s \n" ICE_AGRIF
-printf "%-15s \n" ISOMIP
+printf "%-15s \n" ISOMIP+
 echo ''
Index: utils/CI/sette_ticket2459/sette_rpt.sh
===================================================================
--- utils/CI/sette_ticket2459/sette_rpt.sh	(revision 12876)
+++ utils/CI/sette_ticket2459/sette_rpt.sh	(revision 12878)
@@ -489,5 +489,5 @@
  echo ""
  echo "   !----restart----!   "
- for restart_test in WGYRE_PISCES_ST WORCA2_ICE_PISCES_ST WORCA2_OFF_PISCES_ST WAMM12_ST WORCA2_SAS_ICE_ST WAGRIF_DEMO_ST WSPITZ12_ST WISOMIP_ST WOVERFLOW_ST WLOCK_EXCHANGE_ST WVORTEX_ST WICE_AGRIF_ST 
+ for restart_test in WGYRE_PISCES_ST WORCA2_ICE_PISCES_ST WORCA2_OFF_PISCES_ST WAMM12_ST WORCA2_SAS_ICE_ST WAGRIF_DEMO_ST WSPITZ12_ST WISOMIP+_ST WOVERFLOW_ST WLOCK_EXCHANGE_ST WVORTEX_ST WICE_AGRIF_ST 
  do
    resttest $NEMO_VALID $restart_test $pass
@@ -497,5 +497,5 @@
  echo ""
  echo "   !----repro----!   "
- for repro_test in WGYRE_PISCES_ST WORCA2_ICE_PISCES_ST WORCA2_OFF_PISCES_ST WAMM12_ST WORCA2_SAS_ICE_ST WORCA2_ICE_OBS_ST WAGRIF_DEMO_ST WSPITZ12_ST WISOMIP_ST WVORTEX_ST WICE_AGRIF_ST
+ for repro_test in WGYRE_PISCES_ST WORCA2_ICE_PISCES_ST WORCA2_OFF_PISCES_ST WAMM12_ST WORCA2_SAS_ICE_ST WORCA2_ICE_OBS_ST WAGRIF_DEMO_ST WSPITZ12_ST WISOMIP+_ST WVORTEX_ST WICE_AGRIF_ST
  do
    reprotest $NEMO_VALID $repro_test $pass
@@ -524,5 +524,5 @@
      echo "REFERENCE directory : $NEMO_VALID_REF at rev $NEMO_REV_REF"
      echo ''
-     for repro_test in WGYRE_PISCES_ST WORCA2_ICE_PISCES_ST WORCA2_OFF_PISCES_ST WAMM12_ST WISOMIP_ST WORCA2_SAS_ICE_ST WAGRIF_DEMO_ST WSPITZ12_ST WISOMIP_ST WVORTEX_ST WICE_AGRIF_ST
+     for repro_test in WGYRE_PISCES_ST WORCA2_ICE_PISCES_ST WORCA2_OFF_PISCES_ST WAMM12_ST WISOMIP+_ST WORCA2_SAS_ICE_ST WAGRIF_DEMO_ST WSPITZ12_ST WISOMIP+_ST WVORTEX_ST WICE_AGRIF_ST
      do
        runcmpres $NEMO_VALID $repro_test $NEMO_VALID_REF $NEMO_REV_REF $pass
Index: utils/CI/sette_ticket2459/sette_test-cases.sh
===================================================================
--- utils/CI/sette_ticket2459/sette_test-cases.sh	(revision 12876)
+++ utils/CI/sette_ticket2459/sette_test-cases.sh	(revision 12878)
@@ -150,5 +150,5 @@
 # VORTEX         : 
 # ICE_AGRIF      : 
-# ISOMIP         : 
+# ISOMIP+         : 
 # WAD
 
@@ -726,7 +726,7 @@
 
 # ------
-# ISOMIP
+# ISOMIP+
 # ------
-if [ ${config} == "ISOMIP" ] ;  then
+if [ ${config} == "ISOMIP+" ] ;  then
 ## Restartability tests
     export TEST_NAME="LONG"
@@ -736,9 +736,9 @@
     . ${SETTE_DIR}/all_functions.sh
     #
-    clean_config ISOMIP ISOMIP_ST 'tests'
-    #
-    sync_config  ISOMIP ISOMIP_ST 'tests'
-    #
-    . ./makenemo -m ${CMP_NAM} -n ISOMIP_ST -a ISOMIP -j 8 add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
+    clean_config ISOMIP+ ISOMIP+_ST 'tests'
+    #
+    sync_config  ISOMIP+ ISOMIP+_ST 'tests'
+    #
+    . ./makenemo -m ${CMP_NAM} -n ISOMIP+_ST -a ISOMIP+ -j 8 add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -748,12 +748,12 @@
     clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
-    NPROC=15
+    NPROC=27
     if [ -f ${JOB_FILE} ] ; then \rm ${JOB_FILE} ; fi
     cd ${EXE_DIR}
-    set_namelist namelist_cfg cn_exp \"ISOMIP_LONG\"
-    set_namelist namelist_cfg nn_it000 1
-    set_namelist namelist_cfg nn_itend 96
-    set_namelist namelist_cfg nn_stock 48
-    set_namelist namelist_cfg jpni 5
+    set_namelist namelist_cfg cn_exp \"ISOMIP+_LONG\"
+    set_namelist namelist_cfg nn_it000 1
+    set_namelist namelist_cfg nn_itend 960
+    set_namelist namelist_cfg nn_stock 480
+    set_namelist namelist_cfg jpni 9
     set_namelist namelist_cfg jpnj 3
     set_namelist namelist_cfg sn_cfctl%l_config .true.
@@ -765,5 +765,5 @@
     fi
     cd ${SETTE_DIR}
-    . ./prepare_job.sh input_ISOMIP.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS} ${NEMO_VALID}
+    . ./prepare_job.sh input_ISOMIP+.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS} ${NEMO_VALID}
 
     cd ${SETTE_DIR}
@@ -773,15 +773,15 @@
     clean_valid_dir
     cd ${EXE_DIR}
-    set_namelist namelist_cfg cn_exp \"ISOMIP_SHORT\"
-    set_namelist namelist_cfg nn_it000 49
-    set_namelist namelist_cfg nn_itend 96
-    set_namelist namelist_cfg nn_stock 48
+    set_namelist namelist_cfg cn_exp \"ISOMIP+_SHORT\"
+    set_namelist namelist_cfg nn_it000 481
+    set_namelist namelist_cfg nn_itend 960
+    set_namelist namelist_cfg nn_stock 480
     set_namelist namelist_cfg ln_rstart .true.
     set_namelist namelist_cfg nn_rstctl 2
-    set_namelist namelist_cfg jpni 5
+    set_namelist namelist_cfg jpni 9
     set_namelist namelist_cfg jpnj 3
     set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
-    set_namelist namelist_cfg cn_ocerst_in \"ISOMIP_LONG_00000048_restart\"
+    set_namelist namelist_cfg cn_ocerst_in \"ISOMIP+_LONG_00000480_restart\"
     if [ ${USING_MPMD} == "yes" ] ; then
        set_xio_using_server iodef.xml true
@@ -792,14 +792,14 @@
         L_NPROC=$(( $i - 1 ))
         L_NPROC=`printf "%04d\n" ${L_NPROC}`
-        ln -sf ../LONG/ISOMIP_LONG_00000048_restart_${L_NPROC}.nc .
+        ln -sf ../LONG/ISOMIP+_LONG_00000480_restart_${L_NPROC}.nc .
     done
 
     cd ${SETTE_DIR}
-    . ./prepare_job.sh input_ISOMIP.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS} ${NEMO_VALID}
+    . ./prepare_job.sh input_ISOMIP+.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS} ${NEMO_VALID}
     cd ${SETTE_DIR}
     . ./fcm_job.sh $NPROC ${JOB_FILE} ${INTERACT_FLAG} ${MPIRUN_FLAG}
 
 ## Reproducibility tests
-    export TEST_NAME="REPRO_7_3"
+    export TEST_NAME="REPRO_9_3"
     cd ${MAIN_DIR}
     cd ${SETTE_DIR}
@@ -810,11 +810,11 @@
     clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
-    NPROC=21
+    NPROC=27
     if [ -f ${JOB_FILE} ] ; then \rm ${JOB_FILE} ; fi
     cd ${EXE_DIR}
-    set_namelist namelist_cfg cn_exp \"ISOMIP_73\"
-    set_namelist namelist_cfg nn_it000 1
-    set_namelist namelist_cfg nn_itend 48
-    set_namelist namelist_cfg jpni 7
+    set_namelist namelist_cfg cn_exp \"ISOMIP+_93\"
+    set_namelist namelist_cfg nn_it000 1
+    set_namelist namelist_cfg nn_itend 480
+    set_namelist namelist_cfg jpni 9
     set_namelist namelist_cfg jpnj 3
     set_namelist namelist_cfg sn_cfctl%l_config .true.
@@ -826,5 +826,5 @@
     fi
     cd ${SETTE_DIR}
-    . ./prepare_job.sh input_ISOMIP.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS} ${NEMO_VALID}
+    . ./prepare_job.sh input_ISOMIP+.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS} ${NEMO_VALID}
     cd ${SETTE_DIR}
     . ./fcm_job.sh $NPROC ${JOB_FILE} ${INTERACT_FLAG} ${MPIRUN_FLAG}
@@ -839,7 +839,7 @@
     if [ -f ${JOB_FILE} ] ; then \rm ${JOB_FILE} ; fi
     cd ${EXE_DIR}
-    set_namelist namelist_cfg cn_exp \"ISOMIP_84\"
-    set_namelist namelist_cfg nn_it000 1
-    set_namelist namelist_cfg nn_itend 48
+    set_namelist namelist_cfg cn_exp \"ISOMIP+_84\"
+    set_namelist namelist_cfg nn_it000 1
+    set_namelist namelist_cfg nn_itend 480
     set_namelist namelist_cfg jpni 8
     set_namelist namelist_cfg jpnj 4
@@ -852,5 +852,5 @@
     fi
     cd ${SETTE_DIR}
-    . ./prepare_job.sh input_ISOMIP.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS} ${NEMO_VALID}
+    . ./prepare_job.sh input_ISOMIP+.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS} ${NEMO_VALID}
     cd ${SETTE_DIR}
     . ./fcm_job.sh $NPROC ${JOB_FILE} ${INTERACT_FLAG} ${MPIRUN_FLAG}